//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Silver
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_minimum -100
#property indicator_maximum  100


extern int    RsiPeriod  = 14;
extern int    RsiPrice   = PRICE_CLOSE;
extern int    AroonPeriod= 25;
extern double Filter     = 50;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double rsi[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,rsi);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
   IndicatorShortName("Aroon oscillator ("+RsiPeriod+","+AroonPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
      if (buffer1[limit] >  Filter) CleanPoint(limit,buffer2,buffer3);
      if (buffer1[limit] < -Filter) CleanPoint(limit,buffer4,buffer5);
      for(i=limit; i>=0; i--)
      {
         rsi[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
            double max = rsi[i]; double maxi = 0;
            double min = rsi[i];  double mini = 0;
            for (int k=1; k<=AroonPeriod && (i+k)<Bars; k++)
            {
                if (max<rsi[i+k]) { maxi=k; max = rsi[i+k]; }
                if (min>rsi[i+k]) { mini=k; min = rsi[i+k]; }
            }                  
            buffer1[i] = 100.0*(mini-maxi)/AroonPeriod;
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = EMPTY_VALUE;
            buffer5[i] = EMPTY_VALUE;
                  if (buffer1[i]> Filter) PlotPoint(i,buffer2,buffer3,buffer1);
                  if (buffer1[i]<-Filter) PlotPoint(i,buffer4,buffer5,buffer1);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}